## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Generated by rust2rpm 25
%bcond_without check

%global crate sequoia-sop

%global enabled_features cli,compression,compression-bzip2,compression-deflate,crypto-nettle

Name:           rust-sequoia-sop
Version:        0.31.0
Release:        %autorelease
Summary:        Implementation of the Stateless OpenPGP Interface using Sequoia

License:        GPL-2.0-or-later
URL:            https://crates.io/crates/sequoia-sop
Source:         %{crates_source}
# Manually created patch for downstream crate metadata changes
# * exclude files that are only useful for upstream development
# * remove features for unavailable crypto backends
Patch:          sequoia-sop-fix-metadata.diff

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
An implementation of the Stateless OpenPGP Interface using Sequoia.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSL-1.0
# GPL-2.0-or-later
# LGPL-2.0-or-later
# LGPL-3.0 OR GPL-2.0 OR GPL-3.0
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        GPL-2.0-or-later AND BSL-1.0 AND LGPL-2.0-or-later AND MIT AND Unicode-DFS-2016 AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (LGPL-3.0 OR GPL-2.0 OR GPL-3.0) AND (MIT OR Apache-2.0 OR Zlib) AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE.txt
%license LICENSE.dependencies
%doc README.md
%{_bindir}/sqop
%{_mandir}/man1/sqop*
%{bash_completions_dir}/sqop.bash
%{fish_completions_dir}/sqop.fish
%{zsh_completions_dir}/_sqop

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE.txt
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+cli-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+cli-devel %{_description}

This package contains library source intended for building other packages which
use the "cli" feature of the "%{crate}" crate.

%files       -n %{name}+cli-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+compression-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+compression-devel %{_description}

This package contains library source intended for building other packages which
use the "compression" feature of the "%{crate}" crate.

%files       -n %{name}+compression-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+compression-bzip2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+compression-bzip2-devel %{_description}

This package contains library source intended for building other packages which
use the "compression-bzip2" feature of the "%{crate}" crate.

%files       -n %{name}+compression-bzip2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+compression-deflate-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+compression-deflate-devel %{_description}

This package contains library source intended for building other packages which
use the "compression-deflate" feature of the "%{crate}" crate.

%files       -n %{name}+compression-deflate-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+crypto-nettle-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+crypto-nettle-devel %{_description}

This package contains library source intended for building other packages which
use the "crypto-nettle" feature of the "%{crate}" crate.

%files       -n %{name}+crypto-nettle-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+crypto-openssl-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+crypto-openssl-devel %{_description}

This package contains library source intended for building other packages which
use the "crypto-openssl" feature of the "%{crate}" crate.

%files       -n %{name}+crypto-openssl-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
# ensure all dependencies are available for building tests
%cargo_generate_buildrequires -a

%build
# build binary with the Nettle crypto backend and support for compression
%cargo_build -f %{enabled_features}
%{cargo_license_summary -f %{enabled_features}}
%{cargo_license -f %{enabled_features}} > LICENSE.dependencies

%install
%cargo_install -f %{enabled_features}
# install manual pages
mkdir -p %{buildroot}/%{_mandir}/man1
cp -pav man-sqop/* %{buildroot}/%{_mandir}/man1/
# install shell completions
install -Dpm 0644 target/release/build/%{crate}-*/out/sqop.bash \
    %{buildroot}/%{bash_completions_dir}/sqop.bash
install -Dpm 0644 target/release/build/%{crate}-*/out/sqop.fish \
    %{buildroot}/%{fish_completions_dir}/sqop.fish
install -Dpm 0644 target/release/build/%{crate}-*/out/_sqop \
    %{buildroot}/%{zsh_completions_dir}/_sqop

%if %{with check}
%check
# run tests with Nettle crypto backend (default)
%cargo_test -n -f cli,compression,compression-bzip2,compression-deflate,crypto-nettle
# run tests with OpenSSL crypto backend
%cargo_test -n -f cli,compression,compression-bzip2,compression-deflate,crypto-openssl
%endif

%changelog
* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> 0.31.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Dec 14 2023 Fabio Valentini <decathorpe@gmail.com> 0.31.0-1
- Update to version 0.31.0; Fixes RHBZ#2231909

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> 0.28.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu May 18 2023 Fabio Valentini <decathorpe@gmail.com> 0.28.0-2
- Rebuild for sequoia-openpgp v1.16

* Mon May 08 2023 Fabio Valentini <decathorpe@gmail.com> 0.28.0-1
- Update to version 0.28.0; Fixes RHBZ#2187414

* Fri Apr 14 2023 Fabio Valentini <decathorpe@gmail.com> 0.27.3-1
- Update to version 0.27.3; Fixes RHBZ#2089449

* Sun Feb 26 2023 Fabio Valentini <decathorpe@gmail.com> 0.26.1-5
- Rebuild for bzip2 0.4.4 (CVE-2023-22895 / RUSTSEC-2023-0004)

* Sun Feb 05 2023 Fabio Valentini <decathorpe@gmail.com> 0.26.1-4
- Rebuild for fixed frame pointer compiler flags in Rust RPM macros

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> 0.26.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.26.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Mar 16 2022 Fabio Valentini <decathorpe@gmail.com> 0.26.1-1
- Update to version 0.26.1; Fixes RHBZ#1972711

* Tue Feb 15 2022 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.23.0-4
- Rebuild with package notes

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jun 07 2021 Fabio Valentini <decathorpe@gmail.com> - 0.23.0-1
- Update to version 0.23.0.

* Thu Apr 08 2021 Fabio Valentini <decathorpe@gmail.com> - 0.22.2-1
- Initial package

